// ̃t@C̓V[I[|[c for Java [NXEBU[hɂĐ܂B

package test;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.logging.ConsoleHandler;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.Logger;

import jp.co.hos.coreports.CoReports;
import jp.co.hos.coreports.CrDraw;
import jp.co.hos.coreports.CrFileOutJob;
import jp.co.hos.coreports.CrForm;
import jp.co.hos.coreports.CrJob;
import jp.co.hos.coreports.CrPrintOutJob;
import jp.co.hos.coreports.IRecordSet;
import jp.co.hos.coreports.IReport;
import jp.co.hos.coreports.IReportForm;
import jp.co.hos.coreports.constants.CorFileType;
import jp.co.hos.coreports.events.IEventListener;
import jp.co.hos.coreports.exception.CrException;

/**
 * V[I[|[cgpĒ[쐬sNXłB
 *
 */
public class HokenSampleReport implements IReport {

    private CrDraw crDraw = null;
    private CrJob crJob = null;
    private List reportFormList = null;
    private Map formMap = new HashMap();

    /**
     * CGg|CgłB
     * @param args
     */
    public static void main(String[] args) {
        // ̃NX̃CX^X𐶐܂
        HokenSampleReport report = new HokenSampleReport();
        // R[hZbg̃CX^X𐶐܂
        SimpleCSVRecordSet recordSet = new SimpleCSVRecordSet("HokenSample.csv");
        // [쐬܂
        report.create(recordSet);
    }
    
    /**
     * HokenSampleReport\z܂B
     */
    public HokenSampleReport() {
        // MOLɂ邩ǂݒ肵܂
        enableLogging(true);
    }


    /**
     * [쐬܂B
     * @param recordSet o͑Ώۂ̃R[hZbg
     */
    public synchronized void create(IRecordSet recordSet) {
        try {
            // `NX̃CX^X𐶐܂
            crDraw = createCrDraw();
            // Wu𐶐܂
            crJob = createCrJob();
            // tH[𐶐܂
            reportFormList = createForms();
            try {
                // WuJn܂
                crJob.start(crDraw);
                // |[g܂
                initialize();
                // |[go͂܂
                output(recordSet);
                // WuI܂
                crJob.end();
            } finally {
                // JtH[ׂĕ܂
                closeForms();
                // ُ펞ɂ̓Wuj܂
                // 펞ɂ͉܂
                crJob.abort();
            }

        } catch (CrException cex) {
            // V[I[|[cŔOߑ܂
            cex.printStackTrace();
        } catch (Exception ex) {
            // zO̗Oߑ܂
            ex.printStackTrace();
        } finally {
            // `NX̃CX^X폜܂
            // iPure JavaŃW[gpɂ͉s܂j
            if (crDraw != null) {
                crDraw.deleteInstance();
                crDraw = null;
            }
        }
    }
    
    /**
     * `NX̃CX^X𐶐܂B
     * @return `NX̃CX^X
     * @throws Exception
     */
    private CrDraw createCrDraw() throws Exception {
        // `NX̃CX^X𐶐܂
        CrDraw crDraw = new CrDraw();
        // tH[t@CuĂfBNgݒ肵܂
        crDraw.setFormPath("");
        // hLg쐬fBNgݒ肵܂
        crDraw.setDocumentPath("");
        // 摜̃f[^t@CuĂfBNgݒ肵܂
        crDraw.setDataPath("");
        // ƗpfBNgݒ肵܂
        crDraw.setWorkPath("");
        
        return crDraw;
    }

    /**
     * Wu𐶐܂B
     * @return Wu
     * @throws Exception
     */
    private CrJob createCrJob() throws Exception {
        // t@C^Cvƃt@Cw肵ăt@Co̓Wu𐶐܂
        CrJob crJob = new CrFileOutJob(CorFileType.BINARY, "sample.rsi");
        // [ݒ肵܂
        crJob.setOutputName("یTv");
        // l^f[^tB[h̋󔒂̏o͕@w肵܂
        crJob.setNullBlank(false);
        
        return crJob;
    }

    /**
     * ̒[Ɋ֘A郌|[gtH[𐶐܂B
     * @return |[gtH[̃Xg
     * @throws Exception
     */
    private List createForms() throws Exception {
        ArrayList reportFormList = new ArrayList();

        // HokenSampleReportForm̃CX^X𐶐AXgɓo^܂
        HokenSampleReportForm form0 = new HokenSampleReportForm();
        form0.setCrForm(getCrForm("HokenSample.cfx"));
        form0.setCrDraw(crDraw);
        reportFormList.add(form0);

        return reportFormList;        
    }    

    /*
     * @see jp.co.hos.coreports.IReport#initialize()
     */
    public void initialize() throws CrException {
    }

    /*
     * @see jp.co.hos.coreports.IReport#output(jp.co.hos.coreports.IRecordSet)
     */
    public void output(IRecordSet recordSet) throws CrException {
        while (true) {
            Iterator it = formIterator();
            while (it.hasNext()) {
                if (!recordSet.next()) {
                    return;
                }
                IReportForm reportForm = (IReportForm) it.next();
                reportForm.initialize();
                reportForm.output(recordSet);
            }
        }
    }

    /*
     * @see jp.co.hos.coreports.IReport#addEventListener(jp.co.hos.coreports.events.IEventListener)
     */
    public void addEventListener(IEventListener arg0) throws CrException {

    }

    /*
     * @see jp.co.hos.coreports.IReport#formIterator()
     */
    public Iterator formIterator() throws CrException {
        return reportFormList.listIterator();
    }

    /**
     * Ow肵CrFormIuWFNg擾܂B 
     * ܂JĂȂtH[̏ꍇ̓I[vs܂B
     * 
     * @param formFileName tH[t@C
     * @return CrFormIuWFNg
     * @throws CrException
     */
    private CrForm getCrForm(String formFileName) throws CrException {
        CrForm form = (CrForm) formMap.get(formFileName);
        if (form == null) {
            form = CrForm.open(crDraw, formFileName);
            formMap.put(formFileName, form);
        }
        return form;
    }

    /**
     * JtH[ׂĕ܂B
     * 
     * @throws CrException
     */
    private void closeForms() throws CrException {
        Iterator it = formMap.entrySet().iterator();
        while (it.hasNext()) {
            try {
                ((CrForm) it.next()).close();
            } catch (Exception ex) {
                //
            }
        }
        formMap.clear();
        reportFormList.clear();
    }
    
    /**
     * MO̗LEݒ肵܂B
     * @param enabled LɂꍇAtrue
     */    
    private void enableLogging(boolean enabled) {
        Logger logger = null;
        
        if (enabled) {
            // K[̃CX^X擾܂
            logger = Logger.getAnonymousLogger();
            // K[̏o̓xuSāvɐݒ肵܂
            logger.setLevel(Level.ALL);
            // R\[o͂snh쐬܂
            Handler handler = new ConsoleHandler();
            // nh̏o̓xuSāvɐݒ肵܂
            handler.setLevel(Level.ALL);
            // K[Ƀnhǉ܂
            logger.addHandler(handler);
        } 
        // V[I[|[c̃MO@\ݒ肵܂
        CoReports.setLogger(logger);
    }

    /*
     * @see java.lang.Object#finalize()
     */
    protected void finalize() throws Throwable {
        // V[I[|[c̃MO@\Itɂ܂
        CoReports.setLogger(null);
        
        super.finalize();
    }

}
