// ̃t@C̓V[I[|[c for Java [NXEBU[hɂĐ܂B

package test;
import jp.co.hos.coreports.CrDraw;
import jp.co.hos.coreports.CrForm;
import jp.co.hos.coreports.IRecordSet;
import jp.co.hos.coreports.IReportForm;
import jp.co.hos.coreports.events.IEventListener;
import jp.co.hos.coreports.exception.CrException;
import jp.co.hos.coreports.object.CrBarcodeField;
import jp.co.hos.coreports.object.CrCircle;
import jp.co.hos.coreports.object.CrImageField;
import jp.co.hos.coreports.object.CrListField;
import jp.co.hos.coreports.object.CrPdf417Field;
import jp.co.hos.coreports.object.CrQRField;
import jp.co.hos.coreports.object.CrText;
import jp.co.hos.coreports.object.CrTextField;
import jp.co.hos.coreports.object.IField;

/**
 * tH[t@CɃf[^ݒ肵A[̃y[W̏o͂sNXłB
 * 
 */
public class HokenSampleReportForm implements IReportForm {

    private CrDraw crDraw = null;
    private CrForm crForm = null;
    
    private CrCircle crCircle = null;

    public HokenSampleReportForm() {
        // Iɕ`悷~IuWFNg쐬܂
        crCircle = new CrCircle();
        crCircle.setWidth(1100);
        crCircle.setHeight(400);
        crCircle.setLineWidth(60);
    }

    
    /*
     * @see jp.co.hos.coreports.IReportForm#initialize()
     */
    public void initialize() throws CrException {
        // ANeBuȃv^ɃtH[̗p𔽉f܂
        crDraw.getActivePrinter().setFormSize(crForm);
    }

    /*
     * @see jp.co.hos.coreports.IReportForm#output(jp.co.hos.coreports.IRecordSet)
     */
    public void output(IRecordSet recordSet) throws CrException {
        try {
            // tB[hɃf[^ݒ肵܂
            setFieldData("x", recordSet.getValue("x"));
            setFieldData("xX", recordSet.getValue("xX"));
            setFieldData("x", recordSet.getValue("x"));
            setFieldData("戵", recordSet.getValue("戵"));
            setFieldData("_ԍ", recordSet.getValue("_ԍ"));
            setFieldData("،ԍ1", recordSet.getValue("،ԍ1"));
            setFieldData("N", recordSet.getValue("N"));
            setFieldData("", recordSet.getValue(""));
            setFieldData("", recordSet.getValue(""));
            setFieldData("ی", recordSet.getValue("ی"));
            setFieldData("ی_", recordSet.getValue("ی_"));
            setFieldData("eҖ͌㌩l", recordSet.getValue("eҖ͌㌩l"));
            setFieldData("1", recordSet.getValue("1"));
            setFieldData("_", recordSet.getValue("_"));
            setFieldData("ی", recordSet.getValue("ی"));
            setFieldData("یꊇx", recordSet.getValue("یꊇx"));
            setFieldData("Nԍ폜", recordSet.getValue("Nԍ폜"));
            setFieldData("2", recordSet.getValue("2"));
            setFieldData("Va1", recordSet.getValue("Va1"));
            setFieldData("Vla1", recordSet.getValue("Vla1"));
            setFieldData("sx蕔", recordSet.getValue("sx蕔"));
            setFieldData("񕥍ی", recordSet.getValue("񕥍ی"));
            setFieldData("،ԍ2", recordSet.getValue("،ԍ2"));
            setFieldData("Va2", recordSet.getValue("Va2"));
            setFieldData("Vla2", recordSet.getValue("Vla2"));
        
            // ԁiVaj
            // w̗LɂA\ʒuύX܂
            if ("".equals(recordSet.getValue("Va2"))) {
                crCircle.setStartY(21560);
            } else {
                crCircle.setStartY(22060);
            }
            crCircle.setStartX(5300);
            // ~𓮓Iɕ`悵܂
            crForm.draw(crCircle);

            // ԁiVlaj
            // w̗LɂA\ʒuύX܂
            if ("".equals(recordSet.getValue("Vla2"))) {
                crCircle.setStartY(21560);
            } else {
                crCircle.setStartY(22060);
            }
            crCircle.setStartX(7600);
            // ~𓮓Iɕ`悵܂
            crForm.draw(crCircle);
            
            // 1y[Wo͂܂
            crForm.printOut();
        } catch (CrException cex) {
            throw cex;
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            // tB[hɐݒς݂̃f[^NA܂
            crForm.clearAllFields();
        }
    }
    
    
    
    /*
     * @see jp.co.hos.coreports.IReportForm#addEventListener(jp.co.hos.coreports.events.IEventListener)
     */
    public void addEventListener(IEventListener listener) throws CrException {

    }

    /**
     * CrFormݒ肵܂B
     * @param crForm
     */
    public void setCrForm(CrForm crForm) {
        this.crForm = crForm;
    }
    
    /**
     * CrDrawݒ肵܂B
     * @param crDraw
     */
    public void setCrDraw(CrDraw crDraw) {
        this.crDraw = crDraw;
    }

    /**
     * tB[hɃf[^ݒ肵܂B
     * 
     * @param fieldName tB[h
     * @param data f[^
     * @throws Exception
     */
    private void setFieldData(String fieldName, Object data) throws Exception {
        setFieldData((IField) crForm.getCrObject(fieldName), data);
    }
    
    /**
     * tB[hɃf[^ݒ肵܂B
     * C[WtB[hEQREPDF417̏ꍇ́Aw肳ꂽlt@CƂĉ߂܂B
     * 
     * @param field tB[h
     * @param data f[^
     * @throws Exception
     */
    private void setFieldData(IField field, Object data) throws Exception {
        if (data != null) {
            if (field instanceof CrTextField) {
                ((CrTextField) field).setText((String) data);
            } else if (field instanceof CrBarcodeField) {
                ((CrBarcodeField) field).setData((String) data);
            } else if (field instanceof CrImageField) {
                ((CrImageField) field).loadDataFile((String) data);
            } else if (field instanceof CrQRField) {
                ((CrQRField) field).loadDataFile((String) data);
            } else if (field instanceof CrPdf417Field) {
                ((CrPdf417Field) field).loadDataFile((String) data);
            }
        }
    }
}
